package com.blueland.bpm.manage.config.web;

import javax.servlet.http.HttpServletRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.mvc.support.RedirectAttributes;
import com.blueland.bpm.common.base.BaseSpringController;
import com.blueland.bpm.common.page.Page;
import com.blueland.bpm.common.util.HttpUtils;
/**
 * @author lw
 * @version 1.0
 * @since  
 */
 
import java.util.*;
import com.blueland.bpm.engine.config.model.*;
import com.blueland.bpm.engine.config.dao.*;
import com.blueland.bpm.engine.config.service.*;

@Controller
@RequestMapping(value = "sysScript")
public class SysScriptController extends BaseSpringController{
	//默认多列排序,example: username desc,createTime asc
	protected static final String DEFAULT_SORT_COLUMNS = null; 
	@Autowired
	private SysScriptManager sysScriptManager;
	
	private final String LIST_ACTION = "redirect:/sysScript/list.do";
	
	public SysScriptController() {
	}
	

	/**
	 * 增加了@ModelAttribute的方法可以在本controller的方法调用前执行,可以存放一些共享变量,如枚举值
	 */
	@ModelAttribute
	public void init(ModelMap model) {
		//model.put("now", new java.sql.Timestamp(System.currentTimeMillis()));
	}
	
	/** 
	 * 执行搜索 
	 **/
	@RequestMapping(value = "list")
	public ModelAndView list(HttpServletRequest request,SysScript query) {
		Page page = this.sysScriptManager.findPage(query);
		ModelAndView result = new ModelAndView("/sysScript/list");
		result.addAllObjects(toModelMap(page, query));
		return result;
	}
	
	/** 
	 * 查看对象
	 **/
	@RequestMapping(value = "show")
	public ModelAndView show(HttpServletRequest request)  {
		String id = new String(request.getParameter("scriptId"));
		SysScript sysScript = (SysScript)sysScriptManager.getById(id);
		return new ModelAndView("/sysScript/show","sysScript",sysScript);
	}
	
	/** 
	 * 进入新增页面
	 **/
	@RequestMapping(value = "create")
	public ModelAndView create(HttpServletRequest request,SysScript sysScript)  {
		return new ModelAndView("/sysScript/create","sysScript",sysScript);
	}
	
	/** 
	 * 保存新增对象
	 **/
	@RequestMapping(value = "save")
	public ModelAndView save(HttpServletRequest request,SysScript sysScript,RedirectAttributes redirectAttributes)  {
		sysScriptManager.save(sysScript);
		redirectAttributes.addFlashAttribute(ACTION_MESSAGE, CREATED_SUCCESS);
		return new ModelAndView(LIST_ACTION);
	}
	
	/**
	 * 进入更新页面
	 **/
	@RequestMapping(value = "edit")
	public ModelAndView edit(HttpServletRequest request)  {
		String id = new String(request.getParameter("scriptId"));
		SysScript sysScript = (SysScript)sysScriptManager.getById(id);
		return new ModelAndView("/sysScript/edit","sysScript",sysScript);
	}
	
	/**
	 * 保存更新对象
	 **/
	@RequestMapping(value = "update")
	public ModelAndView update(HttpServletRequest request,SysScript sysScript,RedirectAttributes redirectAttributes)  {
		String id = new String(request.getParameter("scriptId"));
		sysScriptManager.update(sysScript);
		redirectAttributes.addFlashAttribute(ACTION_MESSAGE, UPDATE_SUCCESS);
		return new ModelAndView(LIST_ACTION);
	}
	
	/**
	 *删除对象
	 **/
	@RequestMapping(value = "delete")
	public ModelAndView delete(HttpServletRequest request,RedirectAttributes redirectAttributes) {
		String[] items = request.getParameterValues("items");
		for(int i = 0; i < items.length; i++) {
			Hashtable params = HttpUtils.parseQueryString(items[i]);
			
			String id = new String((String)params.get("scriptId"));
			
			sysScriptManager.removeById(id);
		}
		redirectAttributes.addFlashAttribute(ACTION_MESSAGE, DELETE_SUCCESS);
		return new ModelAndView(LIST_ACTION);
	}
	
}

